# Special things that the slow raycasting system can't do

execute if entity @s[tag=bentenr.FireBlast] run particle flame ^ ^ ^-.5
execute if entity @s[tag=bentenr.FireBlast] run particle flame ~ ~ ~

execute if entity @s[tag=bentenr.FireBall] run particle flame ~ ~ ~ 0.25 0.25 0.25 0 100 force
execute if entity @s[tag=bentenr.FireBall] positioned ^ ^ ^1 unless block ~ ~ ~ #dontcollide run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-1.0d,0.0d],ExplosionPower:2}
execute if entity @s[tag=bentenr.FireBall] positioned ^ ^ ^1 unless block ~ ~ ~ #dontcollide run kill @s
execute if entity @s[tag=bentenr.FireBall] positioned ^ ^ ^1 if entity @e[predicate=!bentenr:slow_raycast,type=!player,dx=0] run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-10.0d,0.0d],ExplosionPower:2}
execute if entity @s[tag=bentenr.FireBall] positioned ^ ^ ^1 if entity @e[predicate=!bentenr:slow_raycast,type=!player,dx=0] run kill @s

execute if entity @s[tag=bentenr.SonicClap] run particle dust 0.75 0.75 0.75 1 ^ ^ ^ 0 0.25 0 0 10 force
execute if entity @s[tag=bentenr.SonicClap] run particle dust 0.75 0.75 0.75 1 ^ ^ ^0.25 0 0.25 0 0 10 force
execute if entity @s[tag=bentenr.SonicClap] run particle dust 0.75 0.75 0.75 1 ^ ^ ^0.5 0 0.25 0 0 10 force
execute if entity @s[tag=bentenr.SonicClap] run particle dust 0.75 0.75 0.75 1 ^ ^ ^0.75 0 0.25 0 0 10 force
execute if entity @s[tag=bentenr.SonicClap] run particle dust 0.75 0.75 0.75 1 ^ ^ ^1 0 0.25 0 0 10 force
execute if entity @s[tag=bentenr.SonicClap] run fill ~5 ~5 ~5 ~-5 ~-5 ~-5 air replace fire
execute if entity @s[tag=bentenr.SonicClap] as @e[distance=..2,type=#bentenr:living] unless score @s bentenr.id = @e[type=area_effect_cloud,limit=1,distance=..1,sort=nearest] bentenr.id run tp @s ~ ~ ~

execute if entity @s[tag=bentenr.Shockwave,scores={bentenr.srcTp=2..}] positioned ~ ~1 ~ run scoreboard players set @e[type=#bentenr:living,distance=..1] bentenr.damage 25
execute if entity @s[tag=bentenr.Shockwave,scores={bentenr.srcTp=1..}] unless block ~ ~ ~ #dontcollide if block ~ ~1 ~ #dontcollide run tp @s ^ ^ ^1
execute if entity @s[tag=bentenr.Shockwave,scores={bentenr.srcTp=1..}] unless block ~ ~1 ~ #dontcollide run tp @s ^ ^1 ^1
execute if entity @s[tag=bentenr.Shockwave,scores={bentenr.srcTp=1..}] if block ~ ~ ~ #dontcollide if block ~ ~1 ~ #dontcollide run tp @s ^ ^-1 ^1
execute if entity @s[tag=bentenr.Shockwave,scores={bentenr.srcTp=2..},predicate=!bentenr:inside_omnitrix] unless block ~ ~ ~ #dontcollide unless block ~ ~ ~ #storage unless block ~ ~ ~ #strong run function bentenr:util/jump_block
execute if entity @s[tag=bentenr.BigShockwave0,scores={bentenr.srcTp=1}] run tp @s ^1 ^ ^
execute if entity @s[tag=bentenr.BigShockwave1,scores={bentenr.srcTp=1}] run tp @s ^-1 ^ ^

execute if entity @s[tag=bentenr.SlimeBlast] run particle item slime_block ~ ~ ~ 0.1 0.1 0.1 0 10 force
execute if entity @s[tag=bentenr.SlimeBlast] as @e[dx=0] unless score @s bentenr.alien matches 6 run effect give @s slowness 10 2 true

execute if entity @s[tag=bentenr.Gas] if block ~ ~ ~ #dontcollide run particle dust 0 1 0 1 ~ ~ ~ 0.2 0.2 0.2 0 10 force
execute if entity @s[tag=bentenr.Gas] unless block ^ ^ ^.1 #dontcollide run particle dust 0 1 0 1 ~ ~ ~ 1 1 1 1 10 force
execute if entity @s[tag=bentenr.Gas] unless block ^ ^ ^.1 #dontcollide run effect give @e[distance=..3] wither 5 0 true
execute if entity @s[tag=bentenr.Gas] unless block ^ ^ ^.1 #dontcollide run effect give @e[distance=..3] slowness 5 0 true
execute if entity @s[tag=bentenr.Gas] unless block ^ ^ ^.1 #dontcollide run effect give @e[distance=..3] blindness 5 0 true

execute if entity @s[tag=bentenr.WaterBlast] run particle dripping_water ~ ~ ~ 0.1 0.1 0.1 0 25 force
execute if entity @s[tag=bentenr.WaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air positioned ^ ^ ^-1 if predicate bentenr:random/25 run fill ~ ~ ~ ~ ~ ~ water replace #air
execute if entity @s[tag=bentenr.WaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air run kill @s

execute if entity @s[tag=bentenr.SwampWaterBlast] run particle dust 0.596 0.714 0.075 1 ~ ~ ~ 0.1 0.1 0.1 0 25 force

execute if entity @s[tag=bentenr.ChargedWaterBlast] run particle dripping_water ~ ~ ~ 0.25 0.25 0.25 0 75 force
execute if entity @s[tag=bentenr.ChargedWaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air positioned ^ ^ ^-1 if predicate bentenr:random/50 run fill ~0.5 ~0.5 ~0.5 ~-0.5 ~-0.5 ~-0.5 water replace #air
execute if entity @s[tag=bentenr.ChargedWaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air run kill @s

execute if entity @s[tag=bentenr.ChargedSwampWaterBlast] run particle dust 0.596 0.714 0.075 1 ~ ~ ~ 0.25 0.25 0.25 0 75 force
execute if entity @s[tag=bentenr.ChargedSwampWaterBlast] run particle dripping_water ~ ~ ~ 0.25 0.25 0.25 0 10 force
execute if entity @s[tag=bentenr.ChargedSwampWaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air positioned ^ ^ ^-1 if predicate bentenr:random/50 run fill ~0.5 ~0.5 ~0.5 ~-0.5 ~-0.5 ~-0.5 water replace #air
execute if entity @s[tag=bentenr.ChargedSwampWaterBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air run kill @s


execute if entity @s[tag=bentenr.VineShot] run particle block acacia_leaves ~ ~ ~ 0.125 0.125 0.125 0 10 force
execute if entity @s[tag=bentenr.VineShot,y_rotation=-135.1..-45] unless block ^ ^ ^1 #air run fill ^ ^ ^ ^ ^ ^ vine[east=true] replace #air
execute if entity @s[tag=bentenr.VineShot,y_rotation=45.1..135] unless block ^ ^ ^1 #air run fill ^ ^ ^ ^ ^ ^ vine[west=true] replace #air
execute if entity @s[tag=bentenr.VineShot,y_rotation=-45..45] unless block ^ ^ ^1 #air run fill ^ ^ ^ ^ ^ ^ vine[south=true] replace #air
execute if entity @s[tag=bentenr.VineShot,y_rotation=135.1..-135] unless block ^ ^ ^1 #air run fill ^ ^ ^ ^ ^ ^ vine[north=true] replace #air
execute if entity @s[tag=bentenr.VineShot] positioned ^ ^ ^1 unless block ~ ~ ~ #air run kill @s

execute if entity @s[tag=bentenr.VineTrap] if block ~ ~ ~ #dontcollide run particle block acacia_leaves ~ ~ ~ 0.125 0.125 0.125 0 10 force
execute if entity @s[tag=bentenr.VineTrap] unless block ^ ^ ^.1 #dontcollide run tag @s add bentenr.wildvine.trap
execute if entity @s[tag=bentenr.VineTrap] unless block ^ ^ ^.1 #dontcollide run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if entity @e[tag=bentenr.wildvine.vine_trapped,distance=..2] run replaceitem entity @s armor.head iron_ingot{CustomModelData:65}
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] unless entity @e[tag=bentenr.wildvine.vine_trapped,distance=..2] run particle block acacia_leaves ~ ~ ~ 0.25 0.25 0.25 0 25 force
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] unless entity @e[tag=bentenr.wildvine.vine_trapped,distance=..2] run tag @e[limit=1,type=!armor_stand,type=!area_effect_cloud,distance=..2] add bentenr.wildvine.vine_trapped
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] run tp @e[limit=1,type=!armor_stand,type=!area_effect_cloud,tag=bentenr.wildvine.vine_trapped,distance=..2] ~ ~ ~
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] run effect give @e[limit=1,type=!armor_stand,type=!area_effect_cloud,tag=bentenr.wildvine.vine_trapped,distance=..2] slowness 1 255 true
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] run effect give @e[limit=1,type=!armor_stand,type=!area_effect_cloud,tag=bentenr.wildvine.vine_trapped,distance=..2] jump_boost 1 250 true
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] run effect give @e[limit=1,type=!armor_stand,type=!area_effect_cloud,tag=bentenr.wildvine.vine_trapped,distance=..2] weakness 1 100 true
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if score @s bentenr.score1 matches 1 run scoreboard players set @e[limit=1,type=!armor_stand,type=!area_effect_cloud,tag=bentenr.wildvine.vine_trapped,distance=..2] bentenr.shock 80
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if entity @e[tag=bentenr.wildvine.vine_trapped,distance=..1] run scoreboard players set @s bentenr.srcTp 0
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if entity @e[tag=bentenr.wildvine.vine_trapped,distance=..1] run scoreboard players add @s bentenr.score1 1
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if score @s bentenr.score1 matches 1.. unless entity @e[tag=bentenr.wildvine.vine_trapped,distance=..1] run kill @s
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if score @s bentenr.score1 matches 100.. run tag @e[limit=1,type=!armor_stand,type=!area_effect_cloud] remove bentenr.wildvine.vine_trapped
execute if entity @s[tag=bentenr.VineTrap,tag=bentenr.wildvine.trap] if score @s bentenr.score1 matches 100.. run kill @s

execute if entity @s[tag=bentenr.ExplosiveSeeds] positioned ^ ^ ^1 unless block ~ ~ ~ #dontcollide run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-1.0d,0.0d],ExplosionPower:3}
execute if entity @s[tag=bentenr.ExplosiveSeeds,tag=bentenr.ShockBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #dontcollide run scoreboard players set @e[distance=..4] bentenr.shock 80
execute if entity @s[tag=bentenr.ExplosiveSeeds] positioned ^ ^ ^1 unless block ~ ~ ~ #dontcollide run kill @s
execute if entity @s[tag=bentenr.ExplosiveSeeds] positioned ^ ^ ^1 if entity @e[predicate=!bentenr:slow_raycast,type=!player,dx=0] run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-10.0d,0.0d],ExplosionPower:3}
execute if entity @s[tag=bentenr.ExplosiveSeeds] positioned ^ ^ ^1 if entity @e[predicate=!bentenr:slow_raycast,type=!player,dx=0] run kill @s

execute if entity @s[tag=bentenr.OpticBeam] run particle dust 0.5 0 0.75 1 ~ ~ ~ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.OpticBeam] run particle dust 0.5 0 0.75 1 ^ ^ ^-.5 0 0 0 0 5 force

execute if entity @s[tag=bentenr.UpgradedPoppy] unless block ^ ^-.1 ^ #dontcollide run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.UpgradedPoppy,tag=bentenr.sRaycast.cancel_tp] run scoreboard players add @s bentenr.score1 1
execute if entity @s[tag=bentenr.UpgradedPoppy,tag=bentenr.sRaycast.cancel_tp] if score @s bentenr.score1 matches 100.. run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-10.0d,0.0d],ExplosionPower:4}
execute if entity @s[tag=bentenr.UpgradedPoppy,tag=bentenr.sRaycast.cancel_tp] if score @s bentenr.score1 matches 100.. run kill @s

execute if entity @s[tag=bentenr.UpgradeFirework] run particle dust 0.5 0 0.75 1 ~ ~ ~ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.UpgradeFirework] unless block ^ ^ ^.1 #dontcollide run summon firework_rocket ~ ~ ~ {LifeTime:1,FireworksItem:{id:"minecraft:firework_rocket",Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1b,Colors:[I;9121481],FadeColors:[I;5643645]}]}}}}
execute if entity @s[tag=bentenr.UpgradeFirework] unless block ^ ^ ^.1 #dontcollide run kill @s

execute if entity @s[tag=bentenr.ShockBlast] run particle dust 0 1 1 1 ~ ~ ~ 0 0 0 0 5 force

execute if entity @s[tag=bentenr.ShockBoomerang] if score @s bentenr.srcTp matches 25.. run tag @s add bentenr.sRaycast.return
execute if entity @s[tag=bentenr.ShockBoomerang,tag=bentenr.sRaycast.return] as @a[scores={bentenr.alien=8},tag=!bentenr.season1,distance=..50] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.ShockBoomerang] bentenr.id run tp @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.ShockBoomerang] ^ ^ ^1 facing entity @s eyes
execute if entity @s[tag=bentenr.ShockBoomerang,tag=bentenr.sRaycast.return] if entity @p[scores={bentenr.alien=8},tag=!bentenr.season1,distance=..4] run kill @s
execute if entity @s[tag=bentenr.ShockBoomerang,tag=bentenr.sRaycast.return] unless entity @p[scores={bentenr.alien=8},tag=!bentenr.season1,distance=..50] run kill @s

execute if entity @s[tag=bentenr.BigShockBlast] run particle dust 0 1 1 1 ~ ~ ~ 0.25 0.25 0.25 0 20 force

execute if entity @s[tag=bentenr.NeuroshockBlast] run particle dust 0 1 0 1 ~ ~ ~ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.NeuroshockBlast] run particle dust 0 1 0 1 ^ ^ ^-.5 0 0 0 0 5 force

execute if entity @s[tag=bentenr.DoubleNeuroshockBlast] run particle dust 0 1 0 1 ^-.25 ^ ^ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.DoubleNeuroshockBlast] run particle dust 0 1 0 1 ^-.25 ^ ^-.5 0 0 0 0 5 force
execute if entity @s[tag=bentenr.DoubleNeuroshockBlast] run particle dust 0 1 0 1 ^.25 ^ ^ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.DoubleNeuroshockBlast] run particle dust 0 1 0 1 ^.25 ^ ^-.5 0 0 0 0 5 force

execute if entity @s[tag=bentenr.RocketFists] run particle dust 0 1 0 1 ~ ~0.5 ~ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.RocketFists] run particle dust 0 1 0 1 ^ ^0.5 ^-.5 0 0 0 0 5 force
execute if entity @s[tag=bentenr.RocketFists] if score @s bentenr.srcTp matches 30.. run tag @s add bentenr.sRaycast.return
execute if entity @s[tag=bentenr.RocketFists,tag=bentenr.sRaycast.return] as @a[scores={bentenr.alien=2},distance=..50] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFists] bentenr.id run tp @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFists] ^ ^ ^1 facing entity @s eyes
execute if entity @s[tag=bentenr.RocketFists,tag=bentenr.sRaycast.return] if entity @p[scores={bentenr.alien=2},distance=..4] run kill @s
execute if entity @s[tag=bentenr.RocketFists,tag=bentenr.sRaycast.return] unless entity @p[scores={bentenr.alien=2},distance=..50] run kill @s


# Rocket Fists Grapple
execute if entity @s[tag=bentenr.RocketFistsGrapple] run particle dust 0 1 0 1 ^1.3 ^0.5 ^ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.RocketFistsGrapple] run particle dust 0 1 0 1 ^-1.3 ^0.5 ^ 0 0 0 0 5 force
execute if entity @s[tag=bentenr.RocketFistsGrapple] run particle dust 0 1 0 1 ^1.3 ^0.5 ^-.5 0 0 0 0 5 force
execute if entity @s[tag=bentenr.RocketFistsGrapple] run particle dust 0 1 0 1 ^-1.3 ^0.5 ^-.5 0 0 0 0 5 force

# Run when don't find any entity or block
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] if score @s bentenr.srcTp matches 100.. run tag @s add bentenr.sRaycast.return
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.return] as @a[scores={bentenr.alien=2},distance=..50] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] bentenr.id run tp @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] ^ ^ ^1 facing entity @s eyes
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.return] if entity @p[scores={bentenr.alien=2},distance=..3] run kill @s
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.return] unless entity @p[scores={bentenr.alien=2},distance=..50] run kill @s

# Run when find block
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] unless block ^ ^ ^1 #dontcollide run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] unless block ^ ^ ^1 #dontcollide run tag @s add bentenr.sRaycast.pull
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] as @a[scores={bentenr.alien=2},distance=..150] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] bentenr.id at @s facing entity @e[type=armor_stand,limit=1,distance=..150,tag=bentenr.RocketFistsGrapple] eyes run tp @s ^ ^ ^1
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] as @a[scores={bentenr.alien=2},distance=..150] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] bentenr.id run tag @s add bentenr.cancel_no_levitation
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] as @a[scores={bentenr.alien=2},distance=..150] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] bentenr.id run effect give @s levitation 1 255 true
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] if entity @p[scores={bentenr.alien=2},distance=..3] run tag @s remove bentenr.cancel_no_levitation
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] if entity @p[scores={bentenr.alien=2},distance=..3] run kill @s
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.pull] unless entity @p[scores={bentenr.alien=2},distance=..150] run kill @s

# Run when find entity
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] if entity @e[type=#bentenr:living,dx=0,type=!player] run tag @e[type=#bentenr:living,dx=0,type=!player,limit=1,tag=!bentenr.sRaycast.entity.grabbed] add bentenr.sRaycast.entity.grabbed
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] if entity @e[type=#bentenr:living,dx=0,type=!player] run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=!bentenr.sRaycast.return,tag=!bentenr.sRaycast.pull,tag=!bentenr.sRaycast.entity] if entity @e[type=#bentenr:living,dx=0,type=!player] run tag @s add bentenr.sRaycast.entity
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.entity] as @a[scores={bentenr.alien=2},distance=..50] if score @s bentenr.id = @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] bentenr.id run tp @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] ^ ^ ^1 facing entity @s eyes
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.entity] as @e[type=armor_stand,limit=1,distance=..1,tag=bentenr.RocketFistsGrapple] run tp @e[type=#bentenr:living,type=!player,distance=..5,sort=nearest,limit=1,tag=bentenr.sRaycast.entity.grabbed] ~ ~-.5 ~
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.entity] if entity @p[scores={bentenr.alien=2},distance=..3] run tag @e[type=#bentenr:living,distance=..5,sort=nearest,type=!player,limit=1,tag=bentenr.sRaycast.entity.grabbed] remove bentenr.sRaycast.entity.grabbed
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.entity] if entity @p[scores={bentenr.alien=2},distance=..3] run kill @s
execute if entity @s[tag=bentenr.RocketFistsGrapple,tag=bentenr.sRaycast.entity] unless entity @p[scores={bentenr.alien=2},distance=..50] run kill @s


execute if entity @s[tag=bentenr.Flamethrower] run particle flame ^ ^ ^-.5
execute if entity @s[tag=bentenr.Flamethrower] run particle flame ~ ~ ~
execute if entity @s[tag=bentenr.Flamethrower] run particle dust 1 0 0 1 ^ ^ ^-.5
execute if entity @s[tag=bentenr.Flamethrower] run particle dust 1 0 0 1 ~ ~ ~
execute if entity @s[tag=bentenr.Flamethrower] run particle dust 1 1 1 1 ~ ~ ~
execute if entity @s[tag=bentenr.Flamethrower] run particle dust 1 1 0 1 ~ ~ ~
execute if entity @s[tag=bentenr.Flamethrower] run particle dust 1 0.75 0 1 ~ ~ ~

execute if entity @s[tag=bentenr.ElectricSpit] run particle dust 0 1 1 1 ~ ~ ~ 0.25 0.25 0.25 0 20 force
execute if entity @s[tag=bentenr.ElectricSpit] run particle item slime_block ~ ~ ~ 0.25 0.25 0.25 0 10 force
execute if entity @s[tag=bentenr.ElectricSpit] as @e[dx=0] unless score @s bentenr.alien matches 6 run effect give @s slowness 5 2 true

execute if entity @s[tag=bentenr.IceBlast] run particle item ice ~ ~ ~ 0.1 0.1 0.1 0 20 force
execute if entity @s[tag=bentenr.IceBlast] positioned ^ ^ ^1 if block ~ ~ ~ water[level=0] run function bentenr:abilities_/water_to_ice
execute if entity @s[tag=bentenr.IceBlast] positioned ^ ^ ^1 if block ~ ~ ~ ice run function bentenr:abilities_/ice_to_packed_ice
execute if entity @s[tag=bentenr.IceBlast] positioned ^ ^ ^1 if block ~ ~ ~ packed_ice run function bentenr:abilities_/packed_ice_to_blue_ice
execute if entity @s[tag=bentenr.IceBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air unless block ~ ~ ~ #minecraft:ice run fill ^-1 ^1 ^ ^1 ^2 ^ ice replace #air
execute if entity @s[tag=bentenr.IceBlast] positioned ^ ^ ^1 unless block ~ ~ ~ #air unless block ~ ~ ~ #minecraft:ice run kill @s



execute if entity @s[tag=bentenr.CerebrospinalBlast] run particle dust 0.839 0.149 0.412 1 ^ ^ ^-.5
execute if entity @s[tag=bentenr.CerebrospinalBlast] run particle dust 0.839 0.149 0.412 1 ~ ~ ~


execute if entity @s[tag=bentenr.CerebrospinalEncasing,scores={bentenr.srcTp=2..}] positioned ^ ^ ^1 if entity @e[type=#bentenr:living,dx=0] run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if entity @e[tag=bentenr.dark_matter.trapped,distance=..2] run replaceitem entity @s armor.head iron_ingot{CustomModelData:191,AttributeModifiers:[{AttributeName:"generic.knockback_resistance",Name:"generic.knockback_resistance",Amount:1,Operation:0,UUID:[I;1105863086,2084850873,-1468940070,1706474438]}]}
execute if entity @s[tag=bentenr.CerebrospinalEncasing] unless entity @e[tag=bentenr.dark_matter.trapped,distance=..2] as @e[limit=1,sort=nearest,type=#bentenr:living,distance=..3] unless score @s bentenr.alien matches -3 run tp @e[type=armor_stand,limit=1,distance=0,tag=bentenr.CerebrospinalEncasing] @s
execute if entity @s[tag=bentenr.CerebrospinalEncasing] unless entity @e[tag=bentenr.dark_matter.trapped,distance=..2] as @e[limit=1,sort=nearest,type=#bentenr:living,distance=..3] unless score @s bentenr.alien matches -3 run tag @s add bentenr.dark_matter.trapped
execute if entity @s[tag=bentenr.CerebrospinalEncasing] run tp @e[limit=1,type=#bentenr:living,tag=bentenr.dark_matter.trapped,distance=..2] ~ ~ ~
execute if entity @s[tag=bentenr.CerebrospinalEncasing] run effect give @e[limit=1,type=#bentenr:living,tag=bentenr.dark_matter.trapped,distance=..2] slowness 1 255 true
execute if entity @s[tag=bentenr.CerebrospinalEncasing] run effect give @e[limit=1,type=#bentenr:living,tag=bentenr.dark_matter.trapped,distance=..2] jump_boost 1 250 true
execute if entity @s[tag=bentenr.CerebrospinalEncasing] run effect give @e[limit=1,type=#bentenr:living,tag=bentenr.dark_matter.trapped,distance=..2] weakness 1 100 true
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if entity @e[tag=bentenr.dark_matter.trapped,distance=..1] run scoreboard players set @s bentenr.srcTp 0
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if entity @e[tag=bentenr.dark_matter.trapped,distance=..1] run scoreboard players add @s bentenr.score1 1
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if score @s bentenr.score1 matches 1.. unless entity @e[tag=bentenr.dark_matter.trapped,distance=..1] run kill @s
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if score @s bentenr.score1 matches 100.. run tag @e[limit=1,type=#bentenr:living,distance=..1,sort=nearest,tag=bentenr.dark_matter.trapped] remove bentenr.dark_matter.trapped
execute if entity @s[tag=bentenr.CerebrospinalEncasing] if score @s bentenr.score1 matches 100.. run kill @s
execute if entity @s[tag=bentenr.CerebrospinalEncasing,tag=!bentenr.sRaycast.cancel_tp] unless block ^ ^ ^1 #dontcollide run kill @s


execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^ ^ 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^0.25 ^ ^ 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^-0.25 ^ ^ 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^0.25 ^ 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^-0.25 ^ 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^ ^0.5 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^0.25 ^ ^0.5 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^-0.25 ^ ^0.5 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^0.25 ^0.5 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^-0.25 ^0.5 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^ ^1 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^0.25 ^ ^1 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^-0.25 ^ ^1 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^.25 ^1 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] run particle dust 0.7 0.7 0.7 1 ^ ^-0.25 ^1 0 0 0 0 10 force
execute if entity @s[tag=bentenr.Roar] as @e[distance=..2,type=#bentenr:living] unless score @s bentenr.id = @e[type=area_effect_cloud,limit=1,distance=..1,sort=nearest] bentenr.id run tp @s ~ ~ ~


execute if entity @s[tag=bentenr.HighOverride.blast] run particle dust .5 0 1 1 ~ ~ ~ 0.25 0.25 0.25 0 20 force



execute if entity @s[tag=bentenr.tetramandSpear,tag=!bentenr.sRaycast.cancel_tp] unless block ^ ^ ^1.4 #dontcollide run scoreboard players set @s bentenr.srcDam 0
execute if entity @s[tag=bentenr.tetramandSpear,tag=!bentenr.sRaycast.cancel_tp] unless block ^ ^ ^1.4 #dontcollide run tag @s add bentenr.sRaycast.cancel_tp
execute if entity @s[tag=bentenr.tetramandSpear,tag=bentenr.sRaycast.cancel_tp] if entity @a[distance=..2] run give @p[gamemode=!creative,gamemode=!spectator] carrot_on_a_stick{bentenr.tetramandSpear:1b,display:{Name:'{"translate":"bentenr.item.tetramand_spear","italic":false,"color":"light_gray"}'},CustomModelData:319,AttributeModifiers:[{AttributeName:"generic.attack_damage",Name:"generic.attack_damage",Slot:"mainhand",Amount:6,Operation:0,UUID:[I;-484522402,1777222700,-1144168832,819832896]},{AttributeName:"generic.attack_speed",Name:"generic.attack_speed",Slot:"mainhand",Amount:-3.35,Operation:0,UUID:[I;56435213,-1673573350,-1498181398,-1985855239]}]}
execute if entity @s[tag=bentenr.tetramandSpear,tag=bentenr.sRaycast.cancel_tp] if entity @a[distance=..2] run kill @s