# Util
scoreboard players add @s[type=#bentenr:living,type=!player] bentenr.id 0
execute if entity @s[scores={bentenr.damage=1..},type=!area_effect_cloud,type=!armor_stand] run function bentenr:util/damage
execute if entity @s[scores={bentenr.setFire=1..}] run function bentenr:util/set_fire
execute if entity @s[scores={bentenr.shock=1..},tag=bentenr.ShockImmune] run scoreboard players set @s bentenr.shock 0
execute if entity @s[scores={bentenr.shock=1..},tag=!bentenr.ShockImmune,type=!area_effect_cloud,type=!armor_stand] run function bentenr:util/shock
execute if entity @s[type=!player] if score @s bentenr.launch matches 1.. run function bentenr:util/launch
execute if entity @s[type=armor_stand,tag=bentenr.launch_player] as @p if entity @s[scores={bentenr.launch=0}] run function bentenr:util/reset_launch_player
execute if entity @s[predicate=bentenr:slow_raycast,tag=bentenr.sRaycast] run function bentenr:util/slow_raycast


# Abilities
execute if entity @s[scores={bentenr.tornado=1..}] run function bentenr:abilities_/tornado
execute if entity @s[type=area_effect_cloud,tag=bentenr.water_walk] align xyz positioned ~0.5 ~1 ~0.5 unless entity @a[distance=..5,scores={OS_Alien=4,bentenr.moving=1..}] positioned ~ ~-1 ~ run fill ~ ~ ~ ~ ~ ~ water replace barrier
execute if entity @s[type=area_effect_cloud,tag=bentenr.water_walk] align xyz positioned ~0.5 ~1 ~0.5 unless entity @a[distance=..5,scores={OS_Alien=4,bentenr.moving=1..}] run kill @s
execute if entity @s[predicate=bentenr:slow_raycast,tag=bentenr.sRaycast,tag=bentenr.sRaycast.done] run function bentenr:abilities_/special
execute if entity @s[type=armor_stand,tag=bentenr.DiamondheadFB] run function bentenr:abilities_/diamondhead_block
execute if entity @s[type=armor_stand,tag=bentenr.DiamondheadSpikes] run function bentenr:abilities_/diamondhead_spikes
execute if entity @s[type=armor_stand,tag=bentenr.FlowerVomit] run function bentenr:abilities_/a_flower_vomit
execute if entity @s[type=armor_stand,tag=bentenr.overflow.water_control] unless entity @a[tag=bentenr.overflow.water_control,distance=..3] run function bentenr:abilities_/a_water_control
execute if entity @s[type=armor_stand,tag=bentenr.undertow.water_control] unless entity @a[tag=bentenr.undertow.water_control,distance=..3] run function bentenr:abilities_/a_swamp_water_control
execute if entity @s[type=area_effect_cloud,tag=bentenr.giant] run function bentenr:abilities_/giant
execute if entity @s[type=armor_stand,tag=bentenr.CrystalfistTentacles] run function bentenr:abilities_/crystalfist_tentacles

execute if entity @s[type=armor_stand,tag=bentenr.slapback.clone_] unless entity @e[type=wolf,tag=bentenr.slapback.clone,distance=..1] run kill @s
execute if entity @s[type=wolf,tag=bentenr.slapback.clone,tag=!bentenr.OmniKix] run function bentenr:abilities_/slapback_clone_abilities
execute if entity @s[type=wolf,tag=bentenr.slapback.clone,tag=bentenr.OmniKix] run function bentenr:abilities_/slapback_omnikix_clone_abilities

execute if entity @s[type=armor_stand,tag=bentenr.diamondhead.clone_] unless entity @e[type=wolf,tag=bentenr.diamondhead.clone,distance=..1] run particle block diamond_block ~ ~1 ~ 0.25 0.5 0.25 0 100 force
execute if entity @s[type=armor_stand,tag=bentenr.diamondhead.clone_] unless entity @e[type=wolf,tag=bentenr.diamondhead.clone,distance=..1] run kill @s
execute if entity @s[type=wolf,tag=bentenr.diamondhead.clone] run function bentenr:abilities_/diamondhead_omnikix_clone_abilities


execute if entity @s[type=armor_stand,tag=bentenr.tetramand.warrior] positioned ~ ~-2 ~ unless entity @e[type=iron_golem,tag=bentenr.tetramand.warrior,distance=..2] positioned ~ ~2 ~ run function bentenr:khoros/mobs/warrior/death
execute if entity @s[type=iron_golem,tag=bentenr.tetramand.warrior] unless data entity @s NoAI run function bentenr:khoros/mobs/warrior/tick
execute if entity @s[type=armor_stand,tag=bentenr.four_wings] positioned ~ ~-2 ~ unless entity @e[type=iron_golem,tag=bentenr.four_wings,distance=..2] positioned ~ ~2 ~ run function bentenr:khoros/mobs/four_wings/death
execute if entity @s[type=iron_golem,tag=bentenr.four_wings] run function bentenr:khoros/mobs/four_wings/tick


# Scoreboards
scoreboard players add @s bentenr.damage 0
scoreboard players add @s bentenr.launch 0
scoreboard players add @s bentenr.flight 0
scoreboard players add @s bentenr.shock 0
execute if entity @s[scores={bentenr.xlr8T=1..},type=#bentenr:living] unless entity @a[scores={bentenr.alien=9},predicate=bentenr:sprinting,distance=..7] run scoreboard players set @s bentenr.xlr8T 0


# Omnitrix Meteor and Key
execute if entity @s[type=item,predicate=bentenr:item/emerald] if entity @e[type=item,predicate=bentenr:item/nether_star,distance=...5] if entity @e[type=item,predicate=bentenr:item/iron_block,distance=...5] run summon armor_stand ~ ~50 ~ {Silent:1b,Fire:1000s,DisabledSlots:2039583,Tags:["bentenr.omniMet"],Invisible:1b,Marker:1b,Invulnerable:1b,ArmorItems:[{},{},{},{id:"minecraft:iron_block",Count:1b}]}
execute if entity @s[type=item,predicate=bentenr:item/emerald] if entity @e[type=item,predicate=bentenr:item/nether_star,distance=...5] if entity @e[type=item,predicate=bentenr:item/iron_block,distance=...5] run kill @e[type=item,predicate=bentenr:item/emerald_nether_star_iron_block,limit=3,distance=...5]
execute if entity @s[type=armor_stand,tag=bentenr.omniMet] run function bentenr:omnitrix/meteor
execute if entity @s[type=area_effect_cloud,tag=bentenr.omnikey] run function bentenr:omnitrix/omnikey

execute if entity @s[type=zombie,tag=bentenr.HighOverride] run function bentenr:high_override/tick
execute if entity @s[type=zombie,tag=bentenr.HighOverride.minion] run function bentenr:high_override/minions
execute if entity @s[type=zombie,tag=bentenr.HighOverride.mind] run function bentenr:high_override/mind_controlled
execute if entity @s[type=armor_stand,tag=bentenr.HighOverride] unless entity @e[type=zombie,tag=bentenr.HighOverride,distance=..2] run function bentenr:high_override/defeat
execute if entity @s[type=armor_stand,tag=bentenr.HighOverride.minion] unless entity @e[type=zombie,tag=bentenr.HighOverride.minion,distance=..2] run kill @s
execute if entity @s[type=armor_stand,tag=bentenr.HighOverride.mind] unless entity @e[type=zombie,tag=bentenr.HighOverride.mind,distance=..2] run kill @s






# Khoros Summon
execute if entity @s[type=cow,predicate=bentenr:in_khoros,tag=!bentenr.checked] unless entity @a[distance=..6] run function bentenr:khoros/mobs/warrior/summon
execute if entity @s[type=cow,predicate=bentenr:in_khoros,tag=!bentenr.checked] run tag @s add bentenr.checked
execute if entity @s[type=item_frame,tag=bentenr.summon.four_wings] run function bentenr:khoros/mobs/four_wings/summon
execute if entity @s[type=silverfish,tag=bentenr.summon.tetramand_warrior] run function bentenr:khoros/mobs/warrior/summon