scoreboard players set @s[predicate=!bentenr:in_space] bentenr.air 1000

# Normal
execute unless entity @s[tag=bentenr.OmniKix] unless score @s bentenr.moving matches 1.. unless score @s bentenr.HCMD matches 78 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:78,display:{Name:'{"text":""}'},HideFlags:63}
execute unless entity @s[tag=bentenr.OmniKix] if score @s bentenr.moving matches 1.. unless score @s bentenr.HCMD matches 79 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:79,display:{Name:'{"text":""}'},HideFlags:63}

# Omni-Kix
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.score1=..1000}] unless score @s bentenr.moving matches 1.. unless score @s bentenr.HCMD matches 80 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:80,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.moving=1..,bentenr.score1=..1000}] unless score @s bentenr.HCMD matches 81 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:81,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.score1=1001..,bentenr.score2=0}] unless score @s bentenr.moving matches 1.. unless score @s bentenr.HCMD matches 132 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:132,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.moving=1..,bentenr.score1=1001..,bentenr.score2=0}] unless score @s bentenr.HCMD matches 133 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:133,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.score1=1001..,bentenr.score2=1}] unless score @s bentenr.HCMD matches 134 run replaceitem entity @s armor.head iron_ingot{bentenr.aliens_clear:10,CustomModelData:134,display:{Name:'{"text":""}'},HideFlags:63}

# Effects
effect give @s regeneration 1 0 true
effect give @s jump_boost 1 0 true
effect give @s[tag=!bentenr.OmniKix] strength 1 5 true
effect give @s[tag=!bentenr.OmniKix] resistance 1 3 true
effect give @s[tag=bentenr.OmniKix] strength 1 6 true
effect give @s[tag=bentenr.OmniKix] resistance 1 4 true

# Actionbar Titles
title @s[scores={bentenr.SIS=7},tag=!bentenr.OmniKix] actionbar {"translate":"bentenr.abilities.jump","color":"#a2662e"}
title @s[scores={bentenr.SIS=6},tag=!bentenr.OmniKix] actionbar {"translate":"bentenr.abilities.roar","color":"#a2662e"}

title @s[scores={bentenr.SIS=8}] actionbar {"translate":"bentenr.abilities.shockwave","color":"#a2662e"}

title @s[scores={bentenr.SIS=7},tag=bentenr.OmniKix] actionbar {"translate":"bentenr.abilities.soundwave","color":"green"}
title @s[scores={bentenr.SIS=6,bentenr.score1=..1000},tag=bentenr.OmniKix] actionbar ["",{"translate":"bentenr.abilities.energy_absorption","color":"dark_green"},{"text":" - ","color":"#005f00"},{"score":{"name":"@s","objective":"bentenr.score1"},"color":"dark_green"}]
title @s[scores={bentenr.SIS=6,bentenr.score1=1001..},tag=bentenr.OmniKix,predicate=!bentenr:sneaking] actionbar ["",{"translate":"bentenr.abilities.energy_absorption","color":"green"},{"text":" - ","color":"#005f00"},{"score":{"name":"@s","objective":"bentenr.score1"},"color":"green"}]
title @s[scores={bentenr.SIS=6,bentenr.score1=1001..},tag=bentenr.OmniKix,predicate=bentenr:sneaking] actionbar {"translate":"bentenr.abilities.energy_breath","color":"green"}

# Offhand Items
execute if score @s bentenr.SIS matches 6 run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{bentenr.aliens_clear:10,CustomModelData:256,display:{Name:'{"text":""}'},HideFlags:63}
execute unless score @s bentenr.SIS matches 6 run clear @s carrot_on_a_stick{CustomModelData:256}

execute unless entity @s[tag=bentenr.OmniKix] if score @s bentenr.SIS matches 8 run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{bentenr.aliens_clear:10,CustomModelData:313,bentenr.shockwave:1b,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.SIS=7..8,bentenr.score1=..1000}] run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{bentenr.aliens_clear:10,CustomModelData:323,bentenr.shockwave:1b,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.OmniKix,scores={bentenr.SIS=7..8,bentenr.score1=1001..}] run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{bentenr.aliens_clear:10,CustomModelData:324,bentenr.shockwave:1b,display:{Name:'{"text":""}'},HideFlags:63}
execute unless score @s bentenr.SIS matches 8 run clear @s[tag=!bentenr.OmniKix] carrot_on_a_stick{bentenr.shockwave:1b}
clear @s[tag=bentenr.OmniKix,scores={bentenr.SIS=1..6}] carrot_on_a_stick{bentenr.shockwave:1b}

# Abilities
execute if entity @s[scores={bentenr.SIS=8,bentenr.click=1..},predicate=!bentenr:sneaking] run function bentenr:abilities/shockwave
execute if entity @s[scores={bentenr.SIS=8,bentenr.click=1..},predicate=bentenr:sneaking] run function bentenr:abilities/big_shockwave
execute if entity @s[scores={bentenr.SIS=7},tag=!bentenr.OmniKix,predicate=bentenr:sneaking] unless block ~ ~ ~ water unless block ~ ~ ~ lava run function bentenr:abilities/jump
execute if entity @s[scores={bentenr.SIS=6,bentenr.click=1..},tag=!bentenr.OmniKix] anchored eyes positioned ^ ^ ^1 run function bentenr:abilities/roar
execute if entity @s[advancements={bentenr:player_hit_entity=true}] if predicate bentenr:sneaking run function bentenr:abilities/iron_golem_hit

# Omni-Kix
execute if entity @s[scores={bentenr.SIS=7,bentenr.click=1..},tag=bentenr.OmniKix] run function bentenr:abilities/soundwave
execute if entity @s[scores={bentenr.SIS=6,bentenr.click=1..,bentenr.score2=0},predicate=bentenr:sneaking] run function bentenr:abilities/activate_ability
execute if entity @s[scores={bentenr.SIS=6,bentenr.click=1..,bentenr.score2=1},predicate=bentenr:sneaking] run function bentenr:abilities/deactivate_ability
execute if entity @s[scores={bentenr.score2=1}] unless score @s bentenr.SIS matches 6 run scoreboard players set @s bentenr.score2 0
execute if entity @s[scores={bentenr.score2=1,bentenr.score1=..1000}] run scoreboard players set @s bentenr.score2 0
execute if entity @s[scores={bentenr.score2=1}] anchored eyes positioned ^ ^2.5 ^1 rotated ~ ~15 run function bentenr:abilities/energy_breath